//---------------------------------------------------------------------------
// Copyright (C) 1999 by Dmitriy Vassiliev
// SlyDiman@mail.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DDCanvas.h"

#include "DDSurfac.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------
/*
namespace Ddcanvas
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(DDCanvas)};
        RegisterComponents("SlyDiman", classes, 0);
    }
}
*/

//---------------------------------------------------------------------------
__fastcall TDDCanvas::TDDCanvas(LPDIRECTDRAWSURFACE7 _pDDSurface) : TCanvas()
{
  pDDSurface = _pDDSurface ;
  Handle = NULL;
}

//---------------------------------------------------------------------------
__fastcall TDDCanvas::~TDDCanvas(void)
{
  Release();
}

//---------------------------------------------------------------------------
void __fastcall TDDCanvas::CreateHandle(void)
{
  if( hDC == NULL && pDDSurface ){
    if( pDDSurface->GetDC( &hDC ) != DD_OK )
      throw Exception("TDDCanvas: Can't get DC for Surface Canvas");
    Handle = hDC;
  }
}

//---------------------------------------------------------------------------
void __fastcall TDDCanvas::Release(void)
{
  if( hDC != NULL ){
    Handle = NULL;
    pDDSurface->ReleaseDC( hDC ) ;
    hDC = NULL ;
  }
}

//---------------------------------------------------------------------------
bool __fastcall TDDCanvas::DrawingAllowed(void)
{
  return( pDDSurface->IsLost() == DD_OK );
}

//---------------------------------------------------------------------------
