//---------------------------------------------------------------------------
// Copyright (C) 1999 by Dmitriy Vassiliev
// SlyDiman@mail.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#ifndef DDCanvasH
#define DDCanvasH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>

#define   DIRECTDRAW_VERSION 0x0700
#include <DDraw.h>

//---------------------------------------------------------------------------
class PACKAGE TDDCanvas : public TCanvas
{
private:
  LPDIRECTDRAWSURFACE7 pDDSurface;
  HDC hDC;

protected:
  void __fastcall CreateHandle(void);

public:
  void __fastcall Release(void);
  bool __fastcall DrawingAllowed(void);
  __fastcall TDDCanvas(LPDIRECTDRAWSURFACE7 _pDDSurface);   // TComponent* Owner);
  __fastcall ~TDDCanvas(void);
};

//---------------------------------------------------------------------------
#endif
 