//---------------------------------------------------------------------------
// Copyright (C) 1999 by Dmitriy Vassiliev
// SlyDiman@mail.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>

#include "DXVer.h"
#include "GetDXVer.h"

#pragma package(smart_init)
#pragma resource "*.res"

/*
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TDXVersion *)
{
    new TDXVersion(NULL);
}
*/

//---------------------------------------------------------------------------
namespace Dxver
{
    void __fastcall PACKAGE Register()
    {
        TComponentClass classes[1] = {__classid(TDXVersion)};
        RegisterComponents("SlyDiman", classes, 0);
    }
}

//---------------------------------------------------------------------------
__fastcall TDXVersion::TDXVersion(TComponent* Owner)
    : TLabel(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TDXVersion::Loaded(void)
{
  TLabel::Loaded();

  char strResult[128];

  DWORD dwDirectXVersion = 0;
  char strDirectXVersion[10];

  HRESULT hr = GetDXVersion( &dwDirectXVersion, strDirectXVersion, 10 );
  if( SUCCEEDED(hr) ){
    if( dwDirectXVersion > 0 )
      snprintf( strResult, 128, TEXT("DirectX %s installed"), strDirectXVersion );
    else
      strncpy( strResult, TEXT("DirectX not installed"), 128 );
    strResult[127] = 0;
  }else{
    snprintf( strResult, 128, TEXT("Unknown version of DirectX installed"), hr );
    strResult[127] = 0;
  }
  Caption = strResult;
}

//---------------------------------------------------------------------------
