//---------------------------------------------------------------------------
// Copyright (C) 2004 by Dmitriy Vassiliev
// SlyDiman@mail.ru
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>

#include "Unit1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "DDSurfac"
#pragma link "DDSprite"
#pragma resource "*.dfm"

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TDDForm(Owner)
{
}               

//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  DDActive = true;             
}

//---------------------------------------------------------------------------
void __fastcall TForm1::DDFormDDUpdateDisplay(TObject *Sender)
{
  RECT BackRect = Rect( 0, 0, DDWidth, DDHeight );
  pDDBack->BltFast( 0, 0, DDSurface2->pDDSurface, &BackRect, DDBLTFAST_WAIT );

//-------------------------------

  // Move sprites
  DDSprite1->Move( Ticks );

//-------------------------------

  // Draw sprites
  DDSprite1->Show( pDDBack, Ticks, DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT );

//-------------------------------

  // FPS

  {
    FlipCount++;
    int t = Ticks - LastTimerTick;

    if( t > 1000 ){
      FPS = FlipCount * 1000 / t;
      LastTimerTick = Ticks;
      FlipCount = 0;
    }
  }

//-------------------------------

  // Show FPS

  if( BackCanvas->DrawingAllowed() ){
    try{
      char s[32];
      sprintf( s, "%.2f fps", FPS );
      int h = BackCanvas->TextHeight("A");
      BackCanvas->TextOut( 10, DDHeight - h, s );
    }
    __finally{
      BackCanvas->Release();
    }
  }

}

//---------------------------------------------------------------------------

