//---------------------------------------------------------------------------
// Copyright (C) 1999 by Dmitriy Vassiliev
// SlyDiman@mail.ru
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#ifndef MdCmdBoxH
#define MdCmdBoxH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>

//---------------------------------------------------------------------------
#include "DDForm.h"

//---------------------------------------------------------------------------
class PACKAGE TDDModesCombo : public TCustomComboBox
{
private:
  bool FShow8bit;
  bool FShow15bit;
  bool FShow16bit;
  bool FShow24bit;
  bool FShow32bit;
  bool FShowRatio4x3;
  DWORD FShowMaxWidth;
  TDDForm *FDDForm;
  void __fastcall SetDDForm(TDDForm *_DDForm);

protected:
    void __fastcall CreateWnd(void);

public:
  void __fastcall Init(void);
  void __fastcall FixIndex(void);
  
    __fastcall TDDModesCombo(TComponent* Owner);

    __property Items;
	__property Text ;

__published:
  __property bool Show8bit  = {read=FShow8bit, write=FShow8bit };
  __property bool Show15bit = {read=FShow15bit,write=FShow15bit};
  __property bool Show16bit = {read=FShow16bit,write=FShow16bit};
  __property bool Show24bit = {read=FShow24bit,write=FShow24bit};
  __property bool Show32bit = {read=FShow32bit,write=FShow32bit};
  __property bool ShowRatio4x3 = {read=FShowRatio4x3,write=FShowRatio4x3};
  __property DWORD ShowMaxWidth = {read=FShowMaxWidth,write=FShowMaxWidth};

  __property TDDForm *DDForm = {read=FDDForm, write=SetDDForm};

	__property Style ;
	__property Color ;
	__property Ctl3D ;
//	__property DragMode ;
//	__property DragCursor ;
	__property DropDownCount ;
	__property Enabled ;
//	__property Font ;
//	__property ImeMode ;
//	__property ImeName ;
	__property ItemHeight ;
//	__property Items ;
//	__property MaxLength ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property Sorted ;
	__property TabOrder ;
	__property TabStop ;
	__property Visible ;
	__property OnChange ;
	__property OnClick ;
	__property OnDblClick ;
//	__property OnDragDrop ;
//	__property OnDragOver ;
//	__property OnDrawItem ;
	__property OnDropDown ;
//	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
//	__property OnKeyDown ;
//	__property OnKeyPress ;
//	__property OnKeyUp ;
//	__property OnMeasureItem ;
//	__property OnStartDrag ;
};

//---------------------------------------------------------------------------
#endif
